/*
   Copyright (C) 2007 - 2009 by Roberto García Carvajal <roberpot@gmail.com>
   Part of libglsws (http://magiccards.wordpress.com)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3
   or at your option any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/

#include <GL/gl.h>
#include "c_oventana.h"

/*******************************************************************************
*
* Método constructor
* Recibe un entero sin signo de 32 bits (registro de banderas)
* Inicializa todos los datos.
*
*******************************************************************************/
c_otexto::c_otexto(GLuint rbe)
{
 _o_x = 10;
 _o_y = 10;
 _o_ancho = 10;
 _o_alto = 10;
 _RBE = rbe;
 _o_colorf[0] = 0.70;
 _o_colorf[1] = 0.70;
 _o_colorf[2] = 0.70;
 _o_colorb[0] = 0.00;
 _o_colorb[1] = 0.00;
 _o_colorb[2] = 0.00;
 _o_tipo = O_T_TEXTO;
 //FIX-ME faltan datos por inicializar.
}

/*******************************************************************************
*
* Método dibujar.
* Recibe dos flotantes x e y.
* Renderiza el texto.
*
*******************************************************************************/
void c_otexto::dibujar(GLfloat x,GLfloat y)
{
 // Coloco otra matriz sobre la pila.
 glPushMatrix();
 glTranslatef(x+_o_x,y+_o_y,0.0);
 // Si es visible...
 if(_RBE & O_VISIBLE)
 {
  // Si es texturado...
  if(_RBE & O_TEXTURADO)
  {
   // Habilito las texturas, elijo la textura y lo dibujo.
   glEnable(GL_TEXTURE_2D);
   //glBindTexture(GL_TEXTURE_2D,_o_texto);
   glBegin(GL_QUADS);
    glTexCoord2f(0.0, 1.0); glVertex2f(0, 0);
    glTexCoord2f(0.0, 0.0); glVertex2f(0, _o_alto);
    glTexCoord2f(1.0, 0.0); glVertex2f(_o_ancho, _o_alto);
    glTexCoord2f(1.0, 1.0); glVertex2f(_o_ancho, 0);
   glEnd();
   glDisable(GL_TEXTURE_2D);
  }
  else
  {
   // Si no elijo el color y lo dibujo (en otra matriz sobre la pila).
   glColor3fv(_o_colort);
   glPushMatrix();
   glTranslatef(1,_o_posicionCentradaVertical,0.0);
   glColor3fv(_o_colort);
   _fuente->FaceSize(_o_textoTamano);
   _fuente->Render(_o_texto.c_str());
   glPopMatrix();
  }
 }
 glPopMatrix();
}

/*******************************************************************************
*
* Método cargar
* Recibe un dato.
* Procesa el dato internamente.
*
*******************************************************************************/
void c_otexto::cargar(c_dato d)
{
 if(d.t_dato() == _T_DATO_STRING)
 {
  _o_texto = d.s();
 }
}

/*******************************************************************************
*
* Método guardar.
* Devuelve el dato asociado.
*
*******************************************************************************/
c_dato c_otexto::guardar()
{
 c_dato d;
 d.sets(_o_texto);
 return d;
}

/*******************************************************************************
*
* Método destructor.
*
*******************************************************************************/
c_otexto::~c_otexto()
{
}
